	PROGRAM DELPHI2DRDI
C CONVERT THE OBSERVED GRAVIMETRIC FACTORS DELTA,PHI AND THEIR ERRORS
C INTO REAL AND IMAGINARY PART OF THE COMPLEX GRAVIMETRIC FACTOR DELTAC WITH THEIR ERRORS.
C THE OCEAN LOADING CORRECTION CAN ALSO BE PERFORMED USING FES2004 OCEAN MODEL (LYARD ET AL. 2006)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NF=9)
      REAL*8 COSLOAD(NF),SINLOAD(NF),ECOSLOAD(NF),ESINLOAD(NF)
	REAL*8 DELR,DELI,EDR,EDI
	CHARACTER*5 CWAVE
	CHARACTER*20 INFILE,CLOAD
	CHARACTER*20 CSTATION,CFILE
	PI=DACOS(-1.0D0)
	DEG2RAD = PI/180
C ETERNA RESULTS GIVEN AS:
C      0.501370 0.911390 Q1    59.0286   1.14802  0.00048  -0.2165   0.0238
C      0.911391 0.947991 O1   308.3005   1.14900  0.00010   0.1322   0.0048
C      0.947992 0.981854 M1    24.2339   1.14920  0.00100   0.3329   0.0497
C      0.981855 0.998631 P1   143.4277   1.14969  0.00021   0.3195   0.0107
C      1.001370 1.004107 K1   433.4073   1.13695  0.00007   0.3533   0.0035
C      1.004108 1.006845 PSI1   3.3924   1.25732  0.00891   0.8029   0.4060
C      1.006846 1.023622 PHI1   6.1720   1.18027  0.00478   0.1797   0.2318
C      1.023623 1.057485 J1    24.2427   1.15619  0.00115   0.2921   0.0570
C      1.057486 1.470243 OO1   13.2612   1.15392  0.00183   0.3563   0.0909
	WRITE(*,*) 'INPUT FILE: '
	READ(5,'(A)') INFILE

	OPEN(1,FILE=INFILE,STATUS='OLD')
	DO I = 1,2
	  READ(1,*)
	ENDDO
	READ(1,'(A)') CSTATION
	CFILE = 'BAYES_'//CSTATION
	WRITE(*,*) 'OUTPUT FILE IS ',CFILE
	OPEN(2,FILE=CFILE,STATUS='UNKNOWN')

	DO I = 1,2
	  READ(1,*)
	ENDDO
	READ(1,*) ICORR

	IF(ICORR.EQ.1) THEN
	  READ(1,'(A20)') CLOAD
	WRITE(*,*) 'CORRECTING FOR OCEAN LOADING EFFECT USING FILE ',CLOAD
	  OPEN(3,FILE=CLOAD)
	  READ(3,*)
	  DO I = 1,NF
	    READ(3,*) CWAVE,COSLOAD(I),SINLOAD(I),ECOSLOAD(I),ESINLOAD(I)
	  ENDDO
	  CLOSE(3)
	ENDIF

	READ(1,*) DELREF
	DO 1 I=1,NF
C ATHEO IS GIVEN IN nm/s2 AND PHI IN DEGREE!
	  READ(1,*) TOTO,TOTO,CWAVE,ATHEO,DELTA,EDELTA,PHI,EPHI
	  COSOBS = ATHEO/10*DELTA*DCOS(PHI*DEG2RAD)
	  SINOBS = ATHEO/10*DELTA*DSIN(PHI*DEG2RAD)
	  ERRCOS = ATHEO/10*DSQRT(DCOS(PHI*DEG2RAD)**2*EDELTA**2+
     *	DELTA**2*DSIN(PHI*DEG2RAD)**2*(EPHI*DEG2RAD)**2)
	  ERRSIN = ATHEO/10*DSQRT(DSIN(PHI*DEG2RAD)**2*EDELTA**2+
     *	DELTA**2*DCOS(PHI*DEG2RAD)**2*(EPHI*DEG2RAD)**2)
	  IF(ICORR.EQ.1) THEN
		COSCORR = COSOBS-COSLOAD(I)
		SINCORR = SINOBS-SINLOAD(I)
		ECOSCORR = DSQRT(ERRCOS**2+ECOSLOAD(I)**2)
		ESINCORR = DSQRT(ERRSIN**2+ESINLOAD(I)**2)
	    DELR = COSCORR/ATHEO*10
	    DELI = SINCORR/ATHEO*10
	    EDR = ECOSCORR/ATHEO*10
	    EDI = ESINCORR/ATHEO*10
	  ELSE
	    DELR = COSOBS/ATHEO*10
	    DELI = SINOBS/ATHEO*10
	    EDR = ERRCOS/ATHEO*10
	    EDI = ERRSIN/ATHEO*10
	  ENDIF
	  WRITE(2,'(4F13.9)') DELR,DELI,EDR,EDI 
    1	CONTINUE
	WRITE(2,*) DELREF
	CLOSE(1)
	CLOSE(2)
	WRITE(*,*) 'DONE'
	PAUSE
	END