C**********************************************************************************************************
C
C				BAYESIAN INVERSION OF THE FREE CORE RESONANCE
C (REF. PAPER: FLORSCH AND HINDERER, 2000. BAYESIAN ESTIMATION OF THE FREE CORE NUTATION PARAMETERS FROM THE 
C ANALYSIS OF PRECISE TIDAL GRAVITY DATA, PEPI, 117, 21-35.)
C
C												Initial code by Nicolas Florsch
C												Revised by Severine Rosat, 2007
C**************************************************************************************************************
C	COMPUTATION OF THE 1D-MARGINAL LAWS FROM THE OUTPUT FILES OF BAYES.FOR
C	READ X-T-.GRD, X-A-.GRD AND T-A-.GRD
C	THE TABLE DIMENSIONS MUST BE CHANGED IF THE BAYESIAN INVERSION ON A GRID SIZE DIFFERENT FROM 201x201x201
C**************************************************************************************************************
	CHARACTER*40,NAME1,NAME2,NAME3
	CHARACTER*4,TOTO
	DIMENSION Z(201,201),XMARG(201),YMARG(201)
	PRINT*,'WARNING! COMPUTATION BASED ON A GRID 201X201'
	PRINT*,'FILENAME TO READ (OUTPUT FROM BAYES.FOR (E.G. T-A-.GRD))'
	READ(*,'(A40)')NAME1
	PRINT*,'OUTPUT FILENAME FOR X-MARGINAL (E.G. X=T)'
	READ(*,'(A40)')NAME2
	PRINT*,'OUTPUT FILENAME FOR Y-MARGINAL (E.G. Y=A)'
	READ(*,'(A40)')NAME3
      OPEN(UNIT=1,FILE=NAME1)
      READ(1,'(A4)')TOTO
      READ(1,*)NX,NY
      READ(1,*)XMIN,XMAX
      READ(1,*)YMIN,YMAX
      READ(1,*)FMIN,FMAX
      DO 3 J=1,NY
        READ(1,'(201G15.3)')(Z(I,J),I=1,NX)
    3 CONTINUE
   99 CONTINUE

      PASX=(XMAX-XMIN)/FLOAT(NX-1)
      PASY=(YMAX-YMIN)/FLOAT(NY-1)

C X-MARGINAL: INTEGRATION ON Y
	NORM = 0.
	DO I=1,NX
	  SUM=0.
	  DO J=1,NY
	    SUM = SUM+Z(I,J)
	  ENDDO
	  XMARG(I) = SUM
	  NORM = NORM + SUM
	ENDDO
C NORMALIZATION OF THE PROBABILITY DENSITY FUNCTION
	DO I = 1,NX
	  XMARG(I) = XMARG(I)/NORM
	ENDDO
C****************************************************
C Y-MARGINAL: INTEGRATION ON X
	NORM = 0.
      DO J=1,NY
	  SUM=0.
	  DO I=1,NX
	    SUM = SUM+Z(I,J)
	  ENDDO
	  YMARG(J) = SUM
	  NORM = NORM + SUM
	ENDDO
C NORMALIZATION OF THE PROBABILITY DENSITY FUNCTION
	DO J = 1,NY
	  YMARG(J) = YMARG(J)/NORM
	ENDDO
C OUTPUT WRITING
	OPEN(UNIT=2, FILE=NAME2)
	DO I=1,NX
	  XX=(I-1)*PASX + XMIN
	  WRITE(2,*)XX,XMARG(I)
	ENDDO
	OPEN(UNIT=3,FILE=NAME3)
	DO J=1,NY
	  YY=(J-1)*PASY + YMIN
	  WRITE(3,*)YY,YMARG(J)
	ENDDO
	END